//funkce vraci textovy retez vypisovany do HTML, ktery zajisti moznost razeni
//tabulky podle sloupce kliknutim na jeho zahlavi

const
  LANG_JS_SORT_CZ='ÁáČčĎďÉéĚěÍíźžĹĺŇňÓóŘřŠšŤťÚúŮůÝýŽž';    //utf-8
  LANG_JS_SORT_EN='AaCcDdEeEeIiLlLlNnOoRrSsTtUuUuYyZz';

function SortTable(iRad:Integer):String; //vraci string s javascriptem pro razeni tabulky podle sloupcu
begin  //iRad je cislo radku tabulky (od 1), ktere bude klikaci
  Result:='<script type="text/javascript">'+CRLF;
  Result:=Result+'addEvent(window, "load", sortables_init);'+CRLF;
  Result:=Result+'var SORT_COLUMN_INDEX;'+CRLF;
  Result:=Result+'var SORT_ROW_FIRST='+IntToStr(iRad)+';'+CRLF;
  Result:=Result+'function trim(myText){'+CRLF
                +'  if (myText != null){'+CRLF
                +'    while (myText.indexOf(". ") != -1 || myText.indexOf(": ") != -1 || myText.indexOf("\n") != -1){'+CRLF
                +'      myText = myText.replace(/\. /,".");'+CRLF
                +'      myText = myText.replace(/\: /,".");'+CRLF
                +'      myText = myText.replace(/\s /,"");'+CRLF
                +'    }'+CRLF
                +'  }'+CRLF
                +'  return myText;'+CRLF
                +'}'+CRLF;
  Result:=Result+'function sortables_init(){'+CRLF
                +'  if (!document.getElementsByTagName) return;'+CRLF
                +'  tbls = document.getElementsByTagName("table");'+CRLF
                +'  for (ti=0;ti<tbls.length;ti++){'+CRLF
                +'    thisTbl = tbls[ti];'+CRLF
                +'    if (((" "+thisTbl.className+" ").indexOf("sortable") != -1) && (thisTbl.id)){'+CRLF
                +'      ts_makeSortable(thisTbl);'+CRLF
                +'    }'+CRLF
                +'  }'+CRLF
                +'}'+CRLF;
  Result:=Result+'function ts_makeSortable(table){'+CRLF
                +'  //if (table.rows && table.rows.length > 0){'+CRLF
                +'  //  var firstRow = table.rows[0];'+CRLF
                +'  if (table.rows && table.rows.length > '+IntToStr(iRad-1)+'){'+CRLF
                +'    var firstRow = table.rows['+IntToStr(iRad-1)+'];'+CRLF
                +'  }'+CRLF
                +'  if (!firstRow) return;'+CRLF
                +'  var cell;'+CRLF
                +'  var txt;'+CRLF
                +'  for (var i=0;i<firstRow.cells.length;i++){'+CRLF
                +'    cell = firstRow.cells[i];'+CRLF
                +'    if (cell.className != "dontsort"){'+CRLF
                +'      txt = ts_getInnerText(cell);'+CRLF
                +'      cell.innerHTML = '+Chr(39)+'<a href="#" class="sortheader" onclick="ts_resortTable(this); return false;">'+Chr(39)+'+txt+'+Chr(39)+'<span class="sortarrow"></span></a>'+Chr(39)+';'+CRLF
                +'    }'+CRLF
                +'  }'+CRLF
                +'}'+CRLF;
  Result:=Result+'function ts_getInnerText(el){'+CRLF
                +'  if (typeof el == "string") return el;'+CRLF
                +'  if (typeof el == "undefined") return el;'+CRLF
                +'  if (el.innerText) return el.innerText;  //Not needed but it is faster'+CRLF
                +'  var str = "";'+CRLF
                +'  var cs = el.childNodes;'+CRLF
                +'  var l = cs.length;'+CRLF
                +'  for (var i = 0; i < l; i++){'+CRLF
                +'    switch (cs[i].nodeType) {'+CRLF
                +'      case 1: //ELEMENT_NODE'+CRLF
                +'        str += ts_getInnerText(cs[i]);'+CRLF
                +'      break;'+CRLF
                +'      case 3:  //TEXT_NODE'+CRLF
                +'        str += cs[i].nodeValue;'+CRLF
                +'      break;'+CRLF
                +'    }'+CRLF
                +'  }'+CRLF
                +'  return str;'+CRLF
                +'}'+CRLF;
  Result:=Result+'function findValidRowInColumn(table,column){'+CRLF
                +'  var ir = 2;//zmeneno z 1 na 2, mame 2 radky zahlavi'+CRLF
                +'  for (ir=2 ;ir < table.rows.length; ir++) {//zmeneno z 1 na 2, mame 2 radky zahlavi'+CRLF
                +'    if (table.rows[ir].cells[column] != undefined && table.rows[ir].cells[column].className != "dontsort" && ts_getInnerText(table.rows[ir].cells[column]).length > 0  && ts_getInnerText(table.rows[ir].cells[column]) != " ")'+CRLF
                +'      return ir;'+CRLF
                +'  }'+CRLF
                +'  return 0;'+CRLF
                +'}'+CRLF;
  Result:=Result+'function ts_resortTable(lnk){'+CRLF
                +'  var span;'+CRLF
                +'  for (var ci=0;ci<lnk.childNodes.length;ci++){'+CRLF
                +'    if (lnk.childNodes[ci].tagName && lnk.childNodes[ci].tagName.toLowerCase() == "span") span = lnk.childNodes[ci];'+CRLF
                +'  }'+CRLF
                +'  var spantext = ts_getInnerText(span);'+CRLF
                +'  var td = lnk.parentNode;'+CRLF
                +'  var column = td.cellIndex;'+CRLF
                +'  var table = getParent(td,"TABLE");'+CRLF
                +'  if (table.rows.length <= 1) return;'+CRLF
                +'  var vr = findValidRowInColumn(table,column);'+CRLF
                +'  var itm = ts_getInnerText(table.rows[vr].cells[column]);'+CRLF
                +'  if (itm.match(/^\d{1,2}[\/.\/-][ ]?\d{1,2}[\/.\/-][ ]?(\d{2}|\d{4})([ ]{0,3}\d{1,2}[:]{1}\d{1,2}([ ]{0}|[:]{1}\d{1,2}))?$/)) sortfn = ts_sort_date;'+CRLF
                +'  else if (itm.match(/^(([Ŕ€L\$])|kÄ© |KÄ© |KÄ« ){1}.*|.*(([Ŕ€L\$])|kÄ© |KÄ© |KÄ« ){1}$/)) sortfn = ts_sort_currency;'+CRLF
                +'  else if (itm.match(/^[\d\,\.\*-]+$/)) sortfn = ts_sort_numeric;'+CRLF
                +'  else sortfn = ts_sort_caseinsensitive;'+CRLF
                +'  SORT_COLUMN_INDEX = column;'+CRLF
                +'  var firstRow = new Array();'+CRLF
                +'  var newRows = new Array();'+CRLF
                +'  var noSortRows = new Array();'+CRLF
                +'  firstRow[0] = table.rows[0];'+CRLF
                +'  //var tableRowIndex = 1;'+CRLF
                +'  var tableRowIndex = SORT_ROW_FIRST;'+CRLF
                +'  var newRowIndex = 0;'+CRLF
                +'  var noSortIndex = 0;'+CRLF
                +'  while (tableRowIndex < table.rows.length){'+CRLF
                +'    if (!table.rows[tableRowIndex].className || (table.rows[tableRowIndex].className && (table.rows[tableRowIndex].className != "dontsort"))){'+CRLF
                +'      newRows[newRowIndex] = table.rows[tableRowIndex];'+CRLF
                +'      newRowIndex++;'+CRLF
                +'    }'+CRLF
                +'    else{'+CRLF
                +'      noSortRows[noSortIndex] = table.rows[tableRowIndex];'+CRLF
                +'      noSortIndex++;'+CRLF
                +'    }'+CRLF
                +'    tableRowIndex++;'+CRLF
                +'  }'+CRLF
                +'  newRows.sort(sortfn);'+CRLF
                +'  if (span.getAttribute("sortdir") == "down"){'+CRLF
                +'    ARROW = "&nbsp;&nbsp;&uarr;";'+CRLF
                +'    newRows.reverse();'+CRLF
                +'    span.setAttribute("sortdir","up");'+CRLF
                +'  }'+CRLF
                +'  else{'+CRLF
                +'    ARROW = "&nbsp;&nbsp;&darr;";'+CRLF
                +'    span.setAttribute("sortdir","down");'+CRLF
                +'  }'+CRLF
                +'  for (i=0;i<noSortRows.length;i++){ newRows[newRows.length] = noSortRows[i]; }'+CRLF
                +'  for (i=0;i<newRows.length;i++){ table.tBodies[0].appendChild(newRows[i]); }'+CRLF
                +'  var allspans = document.getElementsByTagName("span");'+CRLF
                +'  for (var ci=0;ci<allspans.length;ci++)'+CRLF
                +'    if (allspans[ci].className == "sortarrow")'+CRLF
                +'      if (getParent(allspans[ci],"table") == getParent(lnk,"table"))'+CRLF
                +'        allspans[ci].innerHTML = "";'+CRLF
                +'  span.innerHTML = ARROW;'+CRLF
                +'}'+CRLF;

  Result:=Result+'function getParent(el, pTagName){'+CRLF
                +'  if (el == null)'+CRLF
                +'    return null;'+CRLF
                +'  else if (el.nodeType == 1 && el.tagName.toLowerCase() == pTagName.toLowerCase()) return el;'+CRLF
                +'  else return getParent(el.parentNode, pTagName);'+CRLF
                +'}'+CRLF;

  Result:=Result+'function ts_sort_date(a,b){'+CRLF
                +'  var aaDateTime;'+CRLF
                +'  if (a.cells[SORT_COLUMN_INDEX] != undefined && a.cells[SORT_COLUMN_INDEX].className != "dontsort" && ts_getInnerText(a.cells[SORT_COLUMN_INDEX]).length > 0  && ts_getInnerText(a.cells[SORT_COLUMN_INDEX]) != " ")  {'+CRLF
                +'    aa = ts_getInnerText(a.cells[SORT_COLUMN_INDEX]);'+CRLF
                +'    var aaList = trim(aa).split(" ");'+CRLF
                +'    var aaDateList;'+CRLF
                +'    var aaTimeList;'+CRLF
                +'    if (aaList[0].indexOf(".") != -1){// prvniÂ­ je datum'+CRLF
                +'      aaDateList = aaList[0].split(".");'+CRLF
                +'      if (aaList[1] != null && aaList[1].indexOf(":") != -1){ // rozbrakovat cas'+CRLF
                +'        aaTimeList = aaList[1].split(":");'+CRLF
                +'        if (aaTimeList.length > 2) aaDateTime = new Date(aaDateList[2],(aaDateList[1]-1),aaDateList[0],aaTimeList[0],aaTimeList[1],aaTimeList[2]);'+CRLF
                +'        else aaDateTime = new Date(aaDateList[2],(aaDateList[1]-1),aaDateList[0],aaTimeList[0],aaTimeList[1],0);'+CRLF
                +'      }'+CRLF
                +'      else { // jenom datum'+CRLF
                +'        aaDateTime = new Date(aaDateList[2],(aaDateList[1]-1),aaDateList[0]);'+CRLF
                +'      }'+CRLF
                +'    }'+CRLF
                +'    else{ // prvni je cas'+CRLF
                +'      aaTimeList = aaList[1].split(":");'+CRLF
                +'      aaDateList = aaList[0].split(".");'+CRLF
                +'      if (aaTimeList.length > 2) aaDateTime = new Date(aaDateList[2],(aaDateList[1]-1),aaDateList[0],aaTimeList[0],aaTimeList[1],aaTimeList[2]);'+CRLF
                +'      else aaDateTime = new Date(aaDateList[2],(aaDateList[1]-1),aaDateList[0],aaTimeList[0],aaTimeList[1],0);'+CRLF
                +'    }'+CRLF
                +'  }'+CRLF
                +'  else aaDateTime = new Date(1900,0,1);'+CRLF
                +'  var bbDateTime;'+CRLF
                +'  if (b.cells[SORT_COLUMN_INDEX] != undefined && b.cells[SORT_COLUMN_INDEX].className != "dontsort" && ts_getInnerText(b.cells[SORT_COLUMN_INDEX]).length > 0  && ts_getInnerText(b.cells[SORT_COLUMN_INDEX]) != " ")  {'+CRLF
                +'    bb = ts_getInnerText(b.cells[SORT_COLUMN_INDEX]);'+CRLF
                +'    var bbList = trim(bb).split(" ");'+CRLF
                +'    var bbDateList;'+CRLF
                +'    var bbTimeList;'+CRLF
                +'    if (bbList[0].indexOf(".") != -1) {// prvni je datum'+CRLF
                +'      bbDateList = bbList[0].split(".");'+CRLF
                +'      if (bbList[1] != null && bbList[1].indexOf(":") != -1){ // rozbrakovat cas'+CRLF
                +'        bbTimeList = bbList[1].split(":");'+CRLF
                +'        if (bbTimeList.length > 2) bbDateTime = new Date(bbDateList[2],(bbDateList[1]-1),bbDateList[0],bbTimeList[0],bbTimeList[1],bbTimeList[2]);'+CRLF
                +'        else bbDateTime = new Date(bbDateList[2],(bbDateList[1]-1),bbDateList[0],bbTimeList[0],bbTimeList[1],0);'+CRLF
                +'      }'+CRLF
                +'      else{ // jenom datum'+CRLF
                +'        bbDateTime = new Date(bbDateList[2],(bbDateList[1]-1),bbDateList[0]);'+CRLF
                +'      }'+CRLF
                +'    }'+CRLF
                +'    else{ // prvni je cas'+CRLF
                +'      bbTimeList = bbList[1].split(":");'+CRLF
                +'      bbDateList = bbList[0].split(".");'+CRLF
                +'      if (bbTimeList.length > 2) bbDateTime = new Date(bbDateList[2],(bbDateList[1]-1),bbDateList[0],bbTimeList[0],bbTimeList[1],bbTimeList[2]);'+CRLF
                +'      else bbDateTime = new Date(bbDateList[2],(bbDateList[1]-1),bbDateList[0],bbTimeList[0],bbTimeList[1],0);'+CRLF
                +'    }'+CRLF
                +'  }'+CRLF
                +'  else bbDateTime = new Date(1900,0,1);'+CRLF
                +'  if (aaDateTime == bbDateTime) return 0;'+CRLF
                +'  else if (aaDateTime < bbDateTime) return -1;'+CRLF
                +'  else return 1;'+CRLF
                +'}'+CRLF;

  Result:=Result+'function ts_sort_currency(a,b){'+CRLF
                +'  aa = ts_getInnerText(a.cells[SORT_COLUMN_INDEX]).replace(/[^0-9.]/g,'+Chr(39)+Chr(39)+');'+CRLF
                +'  bb = ts_getInnerText(b.cells[SORT_COLUMN_INDEX]).replace(/[^0-9.]/g,'+Chr(39)+Chr(39)+');'+CRLF
                +'  return parseFloat(aa) - parseFloat(bb);'+CRLF
                +'}'+CRLF;

  Result:=Result+'function ts_sort_makenum(a){'+CRLF
                +'  var i,s;'+CRLF
                +'  s="";'+CRLF
                +'  for(i=0;i<a.length;i++){ //vyhodit hvezdicky a carku nahradit teckou'+CRLF
                +'    if(a.charAt(i)==",") s=s+".";'+CRLF
                +'    else if(a.charAt(i)!="*") s=s+a.charAt(i);'+CRLF
                +'  }'+CRLF
                +'  return s;'+CRLF
                +'}'+CRLF;

  Result:=Result+'ts_gord=1; function ts_sort_numeric(a,b){'+CRLF
                +'  var anum=ts_getInnerText(a.cells[SORT_COLUMN_INDEX]);'+CRLF
                +'  var bnum=ts_getInnerText(b.cells[SORT_COLUMN_INDEX]);'+CRLF
                +'  if (a.cells[SORT_COLUMN_INDEX] != undefined && a.cells[SORT_COLUMN_INDEX].className != "dontsort" && ts_getInnerText(a.cells[SORT_COLUMN_INDEX]).length > 0  && ts_getInnerText(a.cells[SORT_COLUMN_INDEX]) != " ")'+CRLF
                +'    aa = parseFloat(ts_sort_makenum(anum));'+CRLF
                +'  else aa = 0;'+CRLF
                +'  if (b.cells[SORT_COLUMN_INDEX] != undefined && b.cells[SORT_COLUMN_INDEX].className != "dontsort" && ts_getInnerText(b.cells[SORT_COLUMN_INDEX]).length > 0  && ts_getInnerText(b.cells[SORT_COLUMN_INDEX]) != " ")'+CRLF
                +'    bb = parseFloat(ts_sort_makenum(bnum));'+CRLF
                +'  else bb = 0;'+CRLF
                +'  return aa-bb;'+CRLF
                +'}'+CRLF;

  Result:=Result+'function char2Diacritic(transDiacritic){'+CRLF
                +'  var charDiacritic = "'+LANG_JS_SORT_CZ+'";'+CRLF
                +'  var numDiacritic = "'+LANG_JS_SORT_EN+'";'+CRLF
                +'  var tmpDiacritic = "";'+CRLF
                +'  var newDiacritic = "";'+CRLF
                +'  transDiacritic = transDiacritic.toUpperCase();'+CRLF
                +'  for(i=0;i<transDiacritic.length;i++){'+CRLF
                +'    if (charDiacritic.indexOf(transDiacritic.charAt(i))!=-1)'+CRLF
                +'      tmpDiacritic += numDiacritic.charAt(charDiacritic.indexOf(transDiacritic.charAt(i)))+"|";'+CRLF
                +'    else'+CRLF
                +'     tmpDiacritic += transDiacritic.charAt(i);'+CRLF
                +'  }'+CRLF
                +'  return tmpDiacritic;'+CRLF
                +'}'+CRLF;

  Result:=Result+'function ts_sort_caseinsensitive(a,b){'+CRLF
                +'  var aa = "_";'+CRLF
                +'  var bb = "_";'+CRLF
                +'  if (a.cells[SORT_COLUMN_INDEX] != undefined && a.cells[SORT_COLUMN_INDEX].className != "dontsort" && ts_getInnerText(a.cells[SORT_COLUMN_INDEX]).length > 0)'+CRLF
                +'    aa = char2Diacritic(ts_getInnerText(a.cells[SORT_COLUMN_INDEX]));'+CRLF
                +'  if (b.cells[SORT_COLUMN_INDEX] != undefined && b.cells[SORT_COLUMN_INDEX].className != "dontsort" && ts_getInnerText(b.cells[SORT_COLUMN_INDEX]).length > 0)'+CRLF
                +'    bb = char2Diacritic(ts_getInnerText(b.cells[SORT_COLUMN_INDEX]));'+CRLF
                +'  if (aa==bb) return 0;'+CRLF
                +'  else if (aa < bb) return -1;'+CRLF
                +'  else return 1;'+CRLF
                +'}'+CRLF;

  Result:=Result+'function ts_sort_default(a,b){'+CRLF
                +'  aa = ts_getInnerText(a.cells[SORT_COLUMN_INDEX]);'+CRLF
                +'  bb = ts_getInnerText(b.cells[SORT_COLUMN_INDEX]);'+CRLF
                +'  if (aa==bb) return 0;'+CRLF
                +'  else if (aa<bb) return -1;'+CRLF
                +'  else return 1;'+CRLF
                +'}'+CRLF;

  Result:=Result+'function addEvent(elm, evType, fn, useCapture){'+CRLF
                +'  if (elm.addEventListener) {'+CRLF
                +'    elm.addEventListener(evType, fn, useCapture);'+CRLF
                +'    return true;'+CRLF
                +'  }'+CRLF
                +'  else if (elm.attachEvent){'+CRLF
                +'    var r = elm.attachEvent("on"+evType, fn);'+CRLF
                +'    return r;'+CRLF
                +'  }'+CRLF
                +'  else{ alert("Handler could not be removed"); }'+CRLF
                +'}'+CRLF;
  Result:=Result+'</script>'+CRLF+CRLF;
end;
